#include <amxmodx>
#include <hamsandwich>
#include <fun>
#include <fakemeta>
#include <engine>
#include <allheroes>
#include <xpsys>
#include <csx>
#include <xs>

// Hero Attributes
new const hclass_name[] = "Halo RED" // name
new const hclass_nameCT[] = "Halo BLUE" // name
const hclass_team = 1 // TEAM 1-T, 2-CT 
const hclass_team2 = 2
new const hclass_modelT[] = "halored" // model CT
new const hclass_modelCT[] = "haloblue" // model T
new const hclass_clawmodel[] = "v_knife_halo.mdl" 	// claw model
new const hclass_skill1[] = "Give me more HP"	// this is lvlHeroSkill(id,1,idhero)
new const hclass_skill2[] = "Update Shield"	// this is lvlHeroSkill(id,2,idhero)
new const hclass_skill3[] = "Update weapon"	// this is lvlHeroSkill(id,3,idhero)
const hclass_health = 500 //  max health
const hclass_speed = 260 // speed 
const Float:hclass_gravity = 0.9 // gravity
new idheroT,idheroCT
new haloshhp[33],halosh[33],bool:halo[33],bool:DM_HALO[33],
msgtext,gIconStatus,halog[33],lastused[33]

public plugin_init()
{
	register_plugin("[AH] Example", "0.1", "CLLlAgOB")
	msgtext = get_user_msgid("StatusText")
	gIconStatus = get_user_msgid("StatusIcon")
	RegisterHam(Ham_TakeDamage, "player", "player_TakeDamage")
	RegisterHam(Ham_Touch, "grenade", "fwdTouch", 1)
	RegisterHam(Ham_Spawn, "player", "fwdSpawn", 1)
}


// Heroes Classes MUST be registered on plugin_precache
public plugin_precache()
{	
	idheroT = ah_register_heroes_class(hclass_name, hclass_team, hclass_modelT, hclass_clawmodel,hclass_skill1,hclass_skill2,hclass_skill3, hclass_health, hclass_speed, hclass_gravity)
	idheroCT = ah_register_heroes_class(hclass_nameCT, hclass_team2, hclass_modelCT, hclass_clawmodel,hclass_skill1,hclass_skill2,hclass_skill3, hclass_health, hclass_speed, hclass_gravity)
}


 //---------------[Set Atrib HERO]--------------- 
public set_atrib_hero(id){
	new class = ah_get_user_heroes_class(id)
	if( class == idheroT || class == idheroCT)
	{
		atrib_set(id)
	} 
	else false_all(id)
}

public atrib_set(id){
	halo[id] = true
	DM_HALO[id] = false
	calc_sh(id)
	new idHero = (get_user_team(id) == 2 ? idheroCT : idheroT)
	halog[id] = lvlHeroSkill(id,3,idHero) + 1
	halosh[id] = lvlHeroSkill(id,2,idHero) + 1
	give_item(id, "weapon_hegrenade")
	if(lvlHeroSkill(id,3,idHero) >= 0) ah_wpn_give(id,CSW_P90)
	if(lvlHeroSkill(id,3,idHero) >= 1) ah_wpn_give(id,CSW_DEAGLE)
	if(lvlHeroSkill(id,3,idHero) == 3) ah_wpn_give(id,CSW_M4A1)
}


public false_all(id){
	halo[id] = false
	haloshhp[id] = false
	DM_HALO[id] = false
}

public calc_sh(id){
	new idHero = (get_user_team(id) == 2 ? idheroCT : idheroT)
	if(lvlHeroSkill(id,2,idHero) <= 0) 		haloshhp[id] = 3 
	else if(lvlHeroSkill(id,2,idHero) == 1)	haloshhp[id] = 4
	else if(lvlHeroSkill(id,2,idHero) == 2)	haloshhp[id] = 6
	else if(lvlHeroSkill(id,2,idHero) == 3)	haloshhp[id] = 10
}

public client_putinserver(id) {
	lastused[id] = get_systime()
}

public cmdShoot(id) {
	if(halo[id] && is_user_alive(id)) {
		if(get_systime() - lastused[id] >= 10) {
			if(halosh[id]>0 && !DM_HALO[id]) {
				calc_sh(id)
				halosh[id]--
				set_pev(id, pev_armorvalue, float(haloshhp[id]))
				client_cmd(id,"spk items/smallmedkit2")
				new HUD[51]
				format(HUD,50,"You got %i shield left.",halosh[id])
				message_begin(MSG_ONE, msgtext, {0,0,0}, id)
				write_byte(0)
				write_string(HUD)
				message_end()
				DM_HALO[id] = true
				message_begin(MSG_ONE,gIconStatus,{0,0,0},id)
				write_byte(1) //1 = show
				write_string("dmg_rad") //Sprite
				write_byte(255) //R
				write_byte(255) //G
				write_byte(0) //B
				message_end()
				set_user_rendering(id,kRenderFxGlowShell,0,180,5,kRenderTransAlpha,255)
				entity_set_int(id, EV_INT_solid, SOLID_NOT)
				armorout(id)
			}
			else {
				set_hudmessage(0,30,200,-1.0,0.75,0,3.0,10.0,0.15,0.5,1)
				show_hudmessage(id,"You are out of power Shield")
			}
		} 
		else {
			new HUD[51]
			format(HUD,50,"Cooldown is %d second%s",10-(get_systime()-lastused[id]),(10-(get_systime()-lastused[id]))>1 ? "s":"")
			message_begin(MSG_ONE, msgtext, {0,0,0}, id)
			write_byte(0)
			write_string(HUD)
			message_end()
		}
	}
	return PLUGIN_HANDLED
}
 
public armorout(id){
	if(haloshhp[id] > 0){
		set_task(1.0,"armorout",id)
		haloshhp[id]--
		set_pev(id, pev_armorvalue, float(haloshhp[id]))
	} else {
		DM_HALO[id] = false
		message_begin(MSG_ONE,gIconStatus,{0,0,0},id)
		write_byte(0)
		write_string("dmg_rad")
		message_end()
		set_user_rendering(id,kRenderFxGlowShell,0,0,0,kRenderTransAlpha,255)	
		entity_set_int(id, EV_INT_solid, SOLID_SLIDEBOX)
		lastused[id] = get_systime()
	}
}
 
 

public player_TakeDamage(victim, inflictor, attacker, Float:damage, damagetype) {
	if(DM_HALO[victim]) SetHamParamFloat(4, 0.0)
	else return HAM_IGNORED
	return HAM_IGNORED
}



public grenade_throw(id, gren, wId)
{
	if (halo[id])
	{
		new Float:vel[3]
		pev(gren, pev_velocity, vel)
		xs_vec_mul_scalar(vel, 2.0, vel)
		set_pev(gren, pev_velocity, vel)
		set_task(0.1, "meshe", id)
	}
}

public meshe(id){
	if (halog[id] > 0)
	{
		give_item(id,"weapon_hegrenade")
		halog[id]--
		set_hudmessage(0, 100, 0, 0.05, 0.65, 1, 0.02, 10.0, 0.01, 0.1, 2)
		show_hudmessage(id,"[AH] %d grenades left!",halog[id])
	}
}

public fwdTouch(grenade, ent)
{
	static owner
	owner = pev(grenade, pev_owner)
	if (halo[owner] && pev(grenade, pev_iuser4) != 1)
	{
		if (is_user_alive(ent))
			set_pev(grenade, pev_dmgtime, get_gametime() - 0.1)
		else
		{
			static Float:vec1[3], Float:vec2[3]
			pev(grenade, pev_velocity, vec1) 
			pev(grenade, pev_origin, vec2)
			xs_vec_normalize(vec1, vec1)
			xs_vec_mul_scalar(vec1, 5.0, vec1)
			xs_vec_sub(vec2, vec1, vec2)
			set_pev(grenade, pev_origin, vec2)
			set_pev(grenade, pev_movetype, MOVETYPE_NONE)
			set_pev(grenade, pev_iuser4, 1)
			set_pev(grenade, pev_velocity, Float:{0.0, 0.0, 0.0})
		}
	}
}

public fwdSpawn(id)
{
	if (is_user_alive(id) && halo[id])
		meshe(id)
}
